/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * input gList.txt
 * output graphList.txt
 *
 *
 */

package sfactor;

import java.io.*;
import java.util.Scanner;
import java.util.*;

/**
 *
 * @author ranjie
 */
public class GraphConverter {

    private static int matrix9[][] ={
            {0,1,1,0,1},
            {1,0,1,1,0},
            {1,1,0,1,0},
            {0,1,1,0,1},
            {1,0,0,1,0},
        };

    private static int matrix10[][] ={
            {0,1,1,0,1,0},
            {1,0,1,1,0,1},
            {1,1,0,1,0,0},
            {0,1,1,0,1,1},
            {1,0,0,1,0,1},
            {0,1,0,1,1,0},

        };

    public static ArrayList readFileGetStrings(String filePath)
    {
        ArrayList<String> stringsList = new ArrayList<String>();//clear aTeamList
        try
        {
           FileReader fr = new FileReader(filePath);
           Scanner parser = new Scanner (fr);
           String teamName;
           while (parser.hasNextLine())
           {
               teamName = parser.nextLine();
               stringsList.add(teamName);
           }
           fr.close();
        }

        catch(FileNotFoundException exception)
        {
           System.out.println("input file" + " not found");
        }
        catch(IOException exception)
        {
           System.out.println("Unexpected I/O error occured");
        }
        return stringsList;
    }


    public static String matrixToId(int[][] matrix){
        String id ="";
        int size = matrix.length;
        for (int i = 0; i < size-1; i++)//row
            for (int j=i+1; j<size; j++)//column
                id = id + matrix[i][j];
        return id;
    }


    public static ArrayList<String> getIds(ArrayList<String> input){
        int size = Integer.parseInt(input.get(0).toString());
        int length = input.size();
        int matrixIndex=0;
        int index = 0;
        int matrixNum=(length/(size+1));
        int matrix[][]= new int[size][size];
        ArrayList<String> graphList = new ArrayList<String>();

        for (int mat=0;mat < matrixNum; mat++){
            for (int i=0; i< size; i++){
                index = mat*(size+1) + i + 1;
                String rowString = input.get(index).toString();
                for (int j=0; j<size; j++)
                    if(j== (size-1)){
                        matrix[i][j]= Integer.parseInt(rowString.substring(j));
                    } else {
                    matrix[i][j]= Integer.parseInt(rowString.substring(j,j+1));
                    }
            }
            String id = matrixToId(matrix);
            graphList.add(id);
        }
        return graphList;
    }

    public static void writeStringsToFile(ArrayList<String> output, String filePath)
    {
        int countGraph = output.size();
        String contents[] = new String[countGraph];
        for(int i=0; i < countGraph; i++){
            contents[i] = output.get(i).toString();
        }

        try
        {
            PrintWriter outWriter = new PrintWriter(filePath);
            for(int i = 0; i < contents.length; i++)
                  outWriter.println(contents[i]);
            outWriter.close();
        }
        catch(IOException e)
        {
            System.out.println("Unexpected I/O error occured");
        }
    }

    public static int[][] idToMatrix(String id) {
        int length = id.length();
        int matrixSize = (int)(Math.sqrt(2*length) + 1);
        //System.out.println(" this graph has "+ matrixSize + " vertices");
        int graphMatrix[][] = new int[matrixSize][matrixSize];

        int index = 0;
        for(int i = 0; i < matrixSize; i++){
            for ( int j= i+1; j < matrixSize; j++){
                if (index >=length){
                   throw new  IllegalArgumentException("Invalid graph id");
                }

                String readbit = id.substring(index, index+1);

                graphMatrix[i][j]= Integer.parseInt( readbit );
                graphMatrix[j][i]= graphMatrix[i][j];
                index++;
            }
        }
        //showMatrix(graphMatrix);
        return graphMatrix;
    }

    public static void showMatrix(int[][] aMatrix) {
        int M = aMatrix.length;
        int N = aMatrix[0].length;
        for (int i = 0; i < M; i++) {
            for (int j = 0; j < N; j++)
                System.out.print(aMatrix[i][j]);
            System.out.println();
        }
    }
    
    public static ArrayList<String> matrixToAdj(int[][] aMatrix) {

        ArrayList<String> aAdjMatrix = new ArrayList<String>();
        int M = aMatrix.length;
        int N = aMatrix[0].length;
        for (int i = 0; i < M; i++) {
            String temp = "";
            for (int j = 0; j < N; j++)
                temp = temp + aMatrix[i][j] + " ";
        aAdjMatrix.add(temp);

        }
        return aAdjMatrix;
    }



    public static void main(String[] args) {
        //String graphId = matrixToId(matrix10);
        // TODO code application logic here
        //System.out.println(graphId);
        ArrayList<String> rawStr = readFileGetStrings("graphMatrix.txt");
        ArrayList<String> graphList = getIds(rawStr);
        //FileIO.displayList(graphList);
        writeStringsToFile(graphList,"graphList.txt");
        // ArrayList<String> aAdj = matrixToAdj(idToMatrix("111111"));
         //ResultConverter.displayList(aAdj);
        //11111111 1111111 111111 11111  1111 111 11 1
        System.out.println("you have so many graphs: "+ rawStr.size());

    }

   




}
